%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Conjugate Direction Method
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc;
clear;
format short;

%%  Լ (  )

Q = [ 5 2 ; 2 1 ];
b = [ 3 1 ];

%   f = @(x) (1/2)*x'*Q*x - x*b'
f = @(x1, x2) (5/2)*x1^2 + (1/2)*x2^2 + 2*x1*x2 - 3*x1 -x2 ;  % Exercise10.7
vf = @(x1, x2) (5/2)*x1.^2 + (1/2)*x2.^2 + 2*x1.*x2 - 3*x1 -x2 ;  % Exercise10.7

syms x1 x2;
gdf1 = diff( f(x1,x2), 'x1'); % x1 x2
gdf2 = diff( f(x1,x2), 'x2'); % x1 x2



%%  (  )
x = [ 300 300 ]';
x1=x(1); x2=x(2);
     g = [ subs(subs(gdf1,x1),x2), ...
           subs(subs(gdf2,x1),x2) ]';
d = -g;
error = 0.001;

% Լ ˰ (Conjugate Method) -   Ұ!!

for count=1:1:inf
        
        %fprintf('stage(%d) \n',count);
        % ȭ  
       if count==1,
              scale = 2.0;  [ i j ] = meshgrid(-scale:0.01:scale , -scale:0.01:scale );
        end;        
        k = vf(i,j);       
        if count==1,
             figure(2);
             meshc(i,j,k);   
        end;
        
        nom = g'* d;
        denom = d'*Q*d;
        a = -nom/denom;
        next_x = x + a * d;

        x1=next_x(1); x2=next_x(2);
        next_g = [ subs(subs(gdf1,x1),x2), subs(subs(gdf2,x1),x2) ]' ;
          
        if count ~= 0,
                nom = next_g'*Q*d;
                denom = d'*Q*d;   
                b = nom/denom;
        else
                b = (next_g'*next_g)/(g'*g);
        end;
  
        next_d =  -next_g + b*d;
        
        x = subs(next_x);
        g = subs(next_g);
        d = subs(next_d);
        
        if abs(g(1))<=error & abs(g(2))<=error,
            break;
        else
            fprintf('stage(%d): g = [ %f %f ]  ,  x = [ %f %f]\n',count, next_g(1), next_g(2), x(1), x(2) );
        end;
        
end;

fprintf('stage(%d): g = [ %f %f ]  ,  x = [ %f %f]\n',count, g(1),g(2), x(1), x(2) );

