%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Newton Method - Rank One
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc;
clear;
format rat;

%%  Լ (  )
H = eye(2,2);
Q = [ 5 2 ; 2 1 ];
b = [ 3 1 ];

%  f = @(x) (1/2)*x'*Q*x - b;
% gf = @(x) Q * x ;

  f = @(x) (1/2)*x'*Q*x-x'*b;
 vf = @(x1, x2) (5/2)*x1.^2 + (1/2)*x2.^2 + 2*x1.*x2 - 3*x1 -x2 ;  % Exercise10.7
 gf = @(x) Q * x - b';

%%  (  )
x =[ -1 1 ]';          % ʱⰪ   
error = 0.001;

%% Լ ˰ (Rank One) -   Ұ!!

% step(1)
g = gf(x);      
d = -g;

for count=1:1:inf  % (1) Rank One g
   
    
%        fprintf('step(%d) :',count);
        % ȭ  
       if count==1,
              scale = 2.0;  [ i j ] = meshgrid(-scale:0.01:scale , -scale:0.01:scale );
        end;        
        k = vf(i,j);       
        if count==1,
             figure(2);
             meshc(i,j,k);   
        end;
        
        % step(2)       
        if abs(g(1))<=error & abs(g(2))<=error, 
               break;
        end;
    
        % step(3)
        a = -(g' * d)/(d'*Q*d);
        next_x = x + a * d;
    
        % ȭ
%        fprintf('   g=[ %f %f ]    alpha=%f   x=[ %f %f ]  \n', ...
%                         g(1),g(2),           a,     x(1),x(2)   );
        fprintf('step(%d): X : %2.4f   %2.4f       g : %2.4f %2.4f ', count,  x(1),x(2), g(1),g(2) ); % ȭ
        fprintf('    alpha: %2.5f\n',   a ); % ȭ

        % step(4)
        delta_x =  a * d;
        next_g  =  gf(next_x); 
        delta_g = next_g - g;
               
        nom = ( delta_x - H * delta_g ) * ( delta_x - H * delta_g )';
        denom = delta_g' * ( delta_x - H * delta_g );
        next_H = H + nom/denom;
        
        % step(2)   ʱȭ
        x = next_x;
        g = next_g; 
        d = -next_H * next_g;
 
end; %(1) ˰  


%% ȭ(  )

 x = next_x;
fprintf('step(%d): X : %2.4f   %2.4f       g : %2.4f %2.4f ', count,  x(1),x(2), g(1),g(2) ); % ȭ
        fprintf('    alpha: %2.5f\n',   a ); % ȭ

disp('End of Program!!');
% End of Program!!