%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Conjugate Direction Method
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc;
clear;
format short;

%%  Լ (  )

 f = @(x1,x2) 100*(x2-x1^2)^2 + (1-x1)^2;
 
syms x1 x2;
gdf1 = diff( f(x1,x2), 'x1'); % x1 x2
gdf2 = diff( f(x1,x2), 'x2'); % x1 x2
 
Q =   [    diff( gdf1,'x1')         ,    diff( gdf1,'x2')     ;  ...
           diff( gdf2,'x1')        ,     diff( gdf2,'x2')     ];

%%  (  )

x = [ -2 2 ]';
x1=x(1); x2=x(2);
     g = [ subs(subs(gdf1,x1),x2), ...
           subs(subs(gdf2,x1),x2) ]';
d = -g;
error = 0.0000001;
 
% Լ ˰ (Conjugate Method) -   Ұ!!

for count=1:1:inf
    
    
        QH = double([   subs(subs(Q(1,1),x(1)),x(2)),   subs(Q(1,2),x(1));...
                       subs(Q(2,1),x(1)),              Q(2,2)           ]);
                    
        %fprintf('stage(%d) \n',count);        
        nom = g'* d;
        denom = d'* QH*d;        
        a = -nom/denom;
        
        next_x = x + a * d;

        next_g = [ subs(subs(gdf1,next_x(1)),next_x(2)), subs(subs(gdf2,next_x(1)),next_x(2)) ]';
          
        if count ~= 0,
                nom = next_g'* QH*d;
                denom = d'* QH*d;
                b = nom/denom;
        else
                b = (next_g'*next_g)/(g'*g);
        end;
  
        next_d =  -next_g + b*d;
        
        x = next_x;
        g = next_g;
        d = next_d;
        
        if ( abs(g(1))<=error && abs(g(2))<=error )
            break;
        else
              fprintf('stage(%d): g = [ %f %f ]\t',count, g(1), g(2) );
              fprintf(', x = [ %f %f ]\n', x(1), x(2) );
          %  fprintf('stage(%d): alpha = %f     beta  = %f\n',count, a, b );
        end;
        
end;

 fprintf('stage(%d): g = [ %f %f ]\t, x = [ %f %f ]\n',count, g(1),g(2), x(1), x(2) );

