%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Quasi Newton Method - (DFP)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc;
clear;
format short;

%%  Լ (  )
 f = @(x1,x2) 100*(x2-x1^2)^2 + (1-x1)^2;  %  10.8
 
syms x1 x2;
gdf1 = diff( f(x1,x2), 'x1'); % x1 x2
gdf2 = diff( f(x1,x2), 'x2'); % x1 x2
 
Q =   [    diff( gdf1,'x1')         ,    diff( gdf1,'x2')     ;  ...
           diff( gdf2,'x1')        ,     diff( gdf2,'x2')     ];
       
H=eye(2,2);

%%  (  )

x = [ -5  5 ]';                                       % ʱⰪ   
select=0;                                            % 0: Secant Search Mehomd (default)
                                                     % 1:   alpha 
error = 0.000001;                                    % 10^-6 

%% Լ ˰ (Rank One) -   Ұ!!

x1=x(1); x2=x(2);
g = [ subs(subs(gdf1,x1),x2), ...
      subs(subs(gdf2,x1),x2) ]';
d = -g;

for count=1:1:inf
       
        QH = double([   subs(subs(Q(1,1),x(1)),x(2) ),   subs(Q(1,2),x(1));...
                             subs(Q(2,1),x(1)),             Q(2,2)           ]);
    
        if abs(g(1))<=error & abs(g(2))<=error,
                    break;
        end;
        
      
        if select == 1,
                 nom = g' * d;
                 denom = d' * QH * d;
                 a = -nom/denom;
        else
                syms  alpha; ax = x - alpha * d;
                sg = @(alpha) subs(diff(  f( ax(1),ax(2) ), 'alpha' ));  % alpha Լ - Լ
    
                % SECANT Ž 
                x_ago = 6.3;           %  
                x_now = 5.1;           %  ǥ
    
                for scount=1:1:inf %(2)for-loop:  Secant ˰ 
                        nom = sg(x_now)*x_ago  - sg(x_ago)*x_now;      % ڼ
                        denom= sg(x_now)   -  sg(x_ago);               % и𼺺 
                        next =nom/denom;                           % x ű ǥ 
    
                        if sg(next) < 0.0000000001,                     % g(x)=0  ٻ  Ž 10^(-10)
                                a = next;
                                break;
                        end; %(1) ּҰ Ȥ İ Ž 
        
                x_ago = x_now;   %  
                x_now = next;  %          
                end; % Secant 
        
        end;   
        
        if select==1,
               next_x = x + a * d;
        else,
               next_x = x - a * d;
        end;
        
        delta_x = next_x - x;
        
        x1=x(1); x2=x(2);
        next_g = double([ subs(subs(gdf1,next_x(1)),next_x(2)), subs(subs(gdf2,next_x(1)),next_x(2)) ]');     % next_g = subs(subs(gf( next_x ),next_x(1) ),next_x(2) );
        
        delta_g = next_g - g;
        
        denom1 = (delta_x' * delta_g );
        denom2 = (delta_g' * H * delta_g);
        if denom1 < 10^-4,                             % ̰ óν ణ(2~3ܰ)  ̵ 
            denom1 = 10000*max(randn(1,5))*denom1;
        elseif  denom2 < 10^-4,
            denom2 = 10000*max(randn(1,5))*denom2;          
        end;
        
        next_H = H + (delta_x  * delta_x')/denom1 - ((  H * delta_g ) * (  H * delta_g )')/denom2;
        next_d = -next_H * next_g;     

        x = next_x;
        g = next_g;
        d = next_d;
        
        % ȭ
        fprintf('Stage(%d):   g=[ %f %f ]    alpha=%f   x=[ %f %f ]  \n', ...
                     count,    g(1),g(2),           a,     x(1),x(2)   );
           
end;


%% ȭ(  )

disp('End of Program!!');
% End of Program!!